/*
 * This file was generated by the CommonAPI Generators.
 * Used org.genivi.commonapi.someip 3.2.0.v202012010944.
 * Used org.franca.core 0.13.1.201807231814.
 *
 * This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
 * If a copy of the MPL was not distributed with this file, You can obtain one at
 * http://mozilla.org/MPL/2.0/.
 */
#ifndef V0_COMMONAPI_DEMO_DEMO_APP1_SOMEIP_PROXY_HPP_
#define V0_COMMONAPI_DEMO_DEMO_APP1_SOMEIP_PROXY_HPP_

#include <v0/commonapi/demo/DemoApp1ProxyBase.hpp>
#include <v0/commonapi/demo/DemoApp1SomeIPDeployment.hpp>
#include <v0/commonapi/demo/CommonTypesSomeIPDeployment.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#define HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

#include <CommonAPI/SomeIP/Factory.hpp>
#include <CommonAPI/SomeIP/Proxy.hpp>
#include <CommonAPI/SomeIP/Types.hpp>
#include <CommonAPI/SomeIP/Attribute.hpp>
#include <CommonAPI/SomeIP/Event.hpp>

#if defined (HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE)
#undef COMMONAPI_INTERNAL_COMPILATION
#undef HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

#include <string>

# if defined(_MSC_VER)
#  if _MSC_VER >= 1300
/*
 * Diamond inheritance is used for the CommonAPI::Proxy base class.
 * The Microsoft compiler put warning (C4250) using a desired c++ feature: "Delegating to a sister class"
 * A powerful technique that arises from using virtual inheritance is to delegate a method from a class in another class
 * by using a common abstract base class. This is also called cross delegation.
 */
#    pragma warning( disable : 4250 )
#  endif
# endif

namespace v0 {
namespace commonapi {
namespace demo {

class DemoApp1SomeIPProxy
    : virtual public DemoApp1ProxyBase,
      virtual public CommonAPI::SomeIP::Proxy {
public:
    DemoApp1SomeIPProxy(
        const CommonAPI::SomeIP::Address &_address,
        const std::shared_ptr<CommonAPI::SomeIP::ProxyConnection> &_connection);

    virtual ~DemoApp1SomeIPProxy();

    virtual UiDemoAttr1Attribute& getUiDemoAttr1Attribute();

    virtual A1DemoAttribute& getA1DemoAttribute();

    virtual DemoStatus1Event& getDemoStatus1Event();

    virtual DemoStatus2Event& getDemoStatus2Event();

    virtual void DemoMethod1(std::string _name, CommonAPI::CallStatus &_internalCallStatus, std::string &_message, const CommonAPI::CallInfo *_info);

    virtual std::future<CommonAPI::CallStatus> DemoMethod1Async(const std::string &_name, DemoMethod1AsyncCallback _callback, const CommonAPI::CallInfo *_info);

    virtual void DemoMethodErr1(std::string _name, CommonAPI::CallStatus &_internalCallStatus, DemoApp1::stdErrorTypeEnum &_error, std::string &_message, const CommonAPI::CallInfo *_info);

    virtual std::future<CommonAPI::CallStatus> DemoMethodErr1Async(const std::string &_name, DemoMethodErr1AsyncCallback _callback, const CommonAPI::CallInfo *_info);

    virtual void DemoMethodTp1(std::string _name, std::vector< int32_t > _data, CommonAPI::CallStatus &_internalCallStatus, std::string &_message, const CommonAPI::CallInfo *_info);

    virtual std::future<CommonAPI::CallStatus> DemoMethodTp1Async(const std::string &_name, const std::vector< int32_t > &_data, DemoMethodTp1AsyncCallback _callback, const CommonAPI::CallInfo *_info);

    virtual void getOwnVersion(uint16_t &_major, uint16_t &_minor) const;

    virtual std::future<void> getCompletionFuture();

private:
    CommonAPI::SomeIP::ObservableAttribute<CommonAPI::SomeIP::Attribute<UiDemoAttr1Attribute, CommonAPI::SomeIP::IntegerDeployment<int32_t>>> uiDemoAttr1_;
    CommonAPI::SomeIP::ObservableAttribute<CommonAPI::SomeIP::Attribute<A1DemoAttribute, ::v0::commonapi::demo::CommonTypes_::a1StructDeployment_t>> a1Demo_;
    CommonAPI::SomeIP::Event<DemoStatus1Event, CommonAPI::Deployable< int32_t, CommonAPI::SomeIP::IntegerDeployment<int32_t> >> demoStatus1_;
    CommonAPI::SomeIP::Event<DemoStatus2Event> demoStatus2_;

    std::promise<void> completed_;
};

} // namespace demo
} // namespace commonapi
} // namespace v0

#endif // V0_COMMONAPI_DEMO_Demo_App1_SOMEIP_PROXY_HPP_
